VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Bitmap Rotate"
   ClientHeight    =   5625
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7005
   ForeColor       =   &H00000000&
   LinkTopic       =   "Form1"
   ScaleHeight     =   5625
   ScaleWidth      =   7005
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox P1 
      BackColor       =   &H00FFFFFF&
      Height          =   1605
      Left            =   15
      ScaleHeight     =   1545
      ScaleWidth      =   6900
      TabIndex        =   6
      Top             =   4005
      Width           =   6960
      Begin VB.Label l4 
         BackStyle       =   0  'Transparent
         Caption         =   "Example Description"
         BeginProperty Font 
            Name            =   "Tahoma"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   60
         TabIndex        =   10
         Top             =   45
         Width           =   1830
      End
      Begin VB.Label l5 
         BackStyle       =   0  'Transparent
         Caption         =   "This demo will show you how to load Bitmap from disk into Memory and perform some operations (i.e. Bitmap Rotation)"
         BeginProperty Font 
            Name            =   "Courier New"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H00FF0000&
         Height          =   555
         Left            =   60
         TabIndex        =   9
         Top             =   315
         Width           =   6735
      End
      Begin VB.Label l7 
         BackStyle       =   0  'Transparent
         Caption         =   "BitBlt, CreateCompatibleBitmap, CreateCompatibleDC, DeleteDC, DeleteObject, GetObject, LoadImage, SelectObject"
         BeginProperty Font 
            Name            =   "Courier New"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H00000080&
         Height          =   435
         Left            =   60
         TabIndex        =   8
         Top             =   1050
         Width           =   7470
      End
      Begin VB.Label l6 
         BackStyle       =   0  'Transparent
         Caption         =   "API"
         BeginProperty Font 
            Name            =   "Tahoma"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   255
         Left            =   60
         TabIndex        =   7
         Top             =   825
         Width           =   1830
      End
   End
   Begin VB.Timer Timer1 
      Left            =   6450
      Top             =   1950
   End
   Begin VB.PictureBox Picture2 
      Height          =   2520
      Left            =   3675
      ScaleHeight     =   2460
      ScaleWidth      =   2715
      TabIndex        =   5
      Top             =   1395
      Width           =   2775
   End
   Begin VB.PictureBox Picture1 
      AutoRedraw      =   -1  'True
      Height          =   2505
      Left            =   45
      ScaleHeight     =   2445
      ScaleWidth      =   2700
      TabIndex        =   4
      Top             =   1410
      Width           =   2760
   End
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   330
      Left            =   1395
      TabIndex        =   3
      Top             =   930
      Width           =   3390
   End
   Begin VB.CommandButton Command1 
      Caption         =   "<< Start"
      Height          =   330
      Left            =   4980
      TabIndex        =   2
      Top             =   945
      Width           =   1500
   End
   Begin VB.Frame Frame1 
      Appearance      =   0  'Flat
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   735
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   10000
      Begin VB.Image Image1 
         Height          =   495
         Left            =   120
         Picture         =   "Form1.frx":0000
         Top             =   120
         Width           =   4140
      End
   End
   Begin VB.Label l1 
      Caption         =   "BMP File Path"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   285
      Left            =   75
      TabIndex        =   1
      Top             =   1035
      Width           =   1335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim sFileName As String      ' filename of the image being used
Dim hBitmap As Long          ' handle to the loaded bitmap
Dim lBMDC As Long            ' device context of the bitmap
Dim sBitmapInfo As BITMAP    ' information on the loaded image
Dim Degrees As Long          ' current rotation degree

Private Sub Command1_Click()
    If Timer1.Enabled = True Then
        Timer1.Enabled = False
        Command1.Caption = "<< Start"
    Else
        Timer1.Enabled = True
        Command1.Caption = "<< Stop"
        Call LoadBMPFromFile
    End If
End Sub

Private Sub Form_Load()
    ' set the timer and turn it on
    Timer1.Interval = 1000
    Timer1.Enabled = False
    Picture2.AutoRedraw = True
    Text1 = App.Path & "\24bit.bmp"
    
    Call LoadBMPFromFile
End Sub

Sub LoadBMPFromFile()
    ' set staring degrees
    Degrees = 0
    sFileName = Text1.Text
    Picture1.Cls
    Picture2.Cls
    ' set the bitmap that will be used in the sample
    'sFileName = "c:\1_24bit.bmp" ' where filename.bmp is the bitmap
    '                            ' being used

    ' load the bitmap into memory
    hBitmap = LoadImage(0, sFileName, IMAGE_BITMAP, 0, 0, _
            LR_LOADFROMFILE Or LR_CREATEDIBSECTION)

    ' make sure the call succeeded
    If (hBitmap = 0) Then
        MsgBox "Error, Unable To Load Bitmap", vbOKOnly, _
                "Bitmap Load Error"
        End
    End If

    ' create a device context to use when blitting the loaded bitmap
    lBMDC = CreateCompatibleDC(0)

    ' make sure our call succeeded
    If (lBMDC = 0) Then
        MsgBox "Error, Unable To Create Device Context", _
                vbOKOnly, "Device Context Error"
        Exit Sub
    End If

    ' attach the bitmap to the device context just created
    Call SelectObject(lBMDC, hBitmap)

    ' get the information about this image
    Call GetObject(hBitmap, Len(sBitmapInfo), sBitmapInfo)

    ' blit the bitmap image onto the picturebox control
    ' on the form to show what is being worked with
    Call BitBlt(Picture1.hdc, 0, 0, sBitmapInfo.bmWidth, _
            sBitmapInfo.bmHeight, lBMDC, 0, 0, SRCCOPY)
    Picture1.Refresh
End Sub
Private Sub Timer1_Timer()
    Dim hRotatedBitmapDC As Long    ' returned DC to the new bitmap
    Dim lWidth As Long       ' current/new width of the bitmaps
    Dim lHeight As Long      ' current/new width of the bitmaps
    Dim lRadians As Long     ' the degrees will be converted to
    ' - radians
    ' get the width/height of the original bitmap image
    lWidth = sBitmapInfo.bmWidth
    lHeight = sBitmapInfo.bmHeight

    ' convert the rotation degrees into radians for the
    ' rotate function
    lRadians = PI * Degrees / 180

    ' set the input var to the current bitmaps DC
    hRotatedBitmapDC = Picture1.hdc

    ' rotate the bitmap to its new degree
    RotateBitmap hRotatedBitmapDC, lWidth, lHeight, lRadians

    ' clear the second picturebox to show the rotated image
    Set Picture2.Picture = LoadPicture

    ' blit the rotated image
    Call BitBlt(Picture2.hdc, 0, 0, lWidth, lHeight, _
            hRotatedBitmapDC, 0, 0, SRCCOPY)
    Picture2.Refresh

    ' destroy the DC created for the rotated bitmap
    Call DeleteDC(hRotatedBitmapDC)

    ' increase the degree count, or reset if we have come full circle
    Degrees = Degrees + 90
    If Degrees = 360 Then
        Degrees = 0
    End If
End Sub
